--- old/usr/src/lib/libfdisk/common/libfdisk.c	2017-04-06 16:31:39.380225338 +0000
+++ new/usr/src/lib/libfdisk/common/libfdisk.c	2017-04-06 16:31:39.428965941 +0000
@@ -770,6 +770,7 @@
 fdisk_read_master_part_table(ext_part_t *epp)
 {
 	struct dk_minfo_ext dkmp_ext;
+	struct dk_minfo dkmp;
 	uchar_t *buf;
 	int sectsize;
 	int size = sizeof (struct ipart);
@@ -779,12 +780,16 @@
 		return (EIO);
 	}
 	if (ioctl(epp->dev_fd, DKIOCGMEDIAINFOEXT, &dkmp_ext) < 0) {
-		return (EIO);
+		if (ioctl(epp->dev_fd, DKIOCGMEDIAINFO, &dkmp) < 0) {
+			return (EIO);
+		}
+		sectsize = dkmp.dki_lbsize;
+	} else {
+		sectsize = dkmp_ext.dki_lbsize;
 	}
-	if (dkmp_ext.dki_lbsize < 512) {
+	if (sectsize < 512) {
 		return (EIO);
 	}
-	sectsize = dkmp_ext.dki_lbsize;
 	buf = calloc(sectsize, sizeof (uchar_t));
 	if (buf == NULL) {
 		return (ENOMEM);
